Index: protocols/skype/skype.c
===================================================================
--- protocols/skype/skype.c	(revision e618d85baf87763ffe7cc1f2b800a5845cf8dfe7)
+++ protocols/skype/skype.c	(revision 441b9dd255ed67ea78467135266d225964ad7041)
@@ -2,5 +2,5 @@
  *  skype.c - Skype plugin for BitlBee
  *
- *  Copyright (c) 2007, 2008, 2009, 2010, 2011, 2012 by Miklos Vajna <vmiklos@frugalware.org>
+ *  Copyright (c) 2007, 2008, 2009, 2010, 2011 by Miklos Vajna <vmiklos@frugalware.org>
  *
  *  This program is free software; you can redistribute it and/or modify
@@ -386,4 +386,6 @@
 	else if (!strncmp(ptr, "LASTONLINETIMESTAMP ", 20))
 		sd->info_seen = g_strdup(ptr + 20);
+	else if (!strncmp(ptr, "BIRTHDAY ", 9))
+		sd->info_birthday = g_strdup(ptr + 9);
 	else if (!strncmp(ptr, "SEX ", 4))
 		sd->info_sex = g_strdup(ptr + 4);
@@ -399,17 +401,5 @@
 		sd->info_homepage = g_strdup(ptr + 9);
 	else if (!strncmp(ptr, "ABOUT ", 6)) {
-		/* Support multiple about lines. */
-		if (!sd->info_about)
-			sd->info_about = g_strdup(ptr + 6);
-		else {
-			GString *st = g_string_new(sd->info_about);
-			g_string_append_printf(st, "\n%s", ptr + 6);
-			g_free(sd->info_about);
-			sd->info_about = g_strdup(st->str);
-			g_string_free(st, TRUE);
-		}
-	}
-	else if (!strncmp(ptr, "BIRTHDAY ", 9)) {
-		sd->info_birthday = g_strdup(ptr + 9);
+		sd->info_about = g_strdup(ptr + 6);
 
 		GString *st = g_string_new("Contact Information\n");
@@ -420,5 +410,4 @@
 					sd->info_fullname);
 			g_free(sd->info_fullname);
-			sd->info_fullname = NULL;
 		}
 		if (sd->info_phonehome) {
@@ -427,5 +416,4 @@
 					sd->info_phonehome);
 			g_free(sd->info_phonehome);
-			sd->info_phonehome = NULL;
 		}
 		if (sd->info_phoneoffice) {
@@ -434,5 +422,4 @@
 					sd->info_phoneoffice);
 			g_free(sd->info_phoneoffice);
-			sd->info_phoneoffice = NULL;
 		}
 		if (sd->info_phonemobile) {
@@ -441,5 +428,4 @@
 					sd->info_phonemobile);
 			g_free(sd->info_phonemobile);
-			sd->info_phonemobile = NULL;
 		}
 		g_string_append_printf(st, "Personal Information\n");
@@ -449,5 +435,4 @@
 					"Contacts: %s\n", sd->info_nrbuddies);
 			g_free(sd->info_nrbuddies);
-			sd->info_nrbuddies = NULL;
 		}
 		if (sd->info_tz) {
@@ -462,5 +447,4 @@
 			}
 			g_free(sd->info_tz);
-			sd->info_tz = NULL;
 		}
 		if (sd->info_seen) {
@@ -474,5 +458,4 @@
 			}
 			g_free(sd->info_seen);
-			sd->info_seen = NULL;
 		}
 		if (sd->info_birthday) {
@@ -494,5 +477,4 @@
 			}
 			g_free(sd->info_birthday);
-			sd->info_birthday = NULL;
 		}
 		if (sd->info_sex) {
@@ -505,5 +487,4 @@
 			}
 			g_free(sd->info_sex);
-			sd->info_sex = NULL;
 		}
 		if (sd->info_language) {
@@ -518,5 +499,4 @@
 			}
 			g_free(sd->info_language);
-			sd->info_language = NULL;
 		}
 		if (sd->info_country) {
@@ -531,5 +511,4 @@
 			}
 			g_free(sd->info_country);
-			sd->info_country = NULL;
 		}
 		if (sd->info_province) {
@@ -538,5 +517,4 @@
 					"Region: %s\n", sd->info_province);
 			g_free(sd->info_province);
-			sd->info_province = NULL;
 		}
 		if (sd->info_city) {
@@ -545,5 +523,4 @@
 					"City: %s\n", sd->info_city);
 			g_free(sd->info_city);
-			sd->info_city = NULL;
 		}
 		if (sd->info_homepage) {
@@ -552,5 +529,4 @@
 					"Homepage: %s\n", sd->info_homepage);
 			g_free(sd->info_homepage);
-			sd->info_homepage = NULL;
 		}
 		if (sd->info_about) {
@@ -559,5 +535,4 @@
 					sd->info_about);
 			g_free(sd->info_about);
-			sd->info_about = NULL;
 		}
 		imcb_log(ic, "%s", st->str);
@@ -1471,4 +1446,5 @@
 	skype_printf(ic, "GET USER %s TIMEZONE\n", nick);
 	skype_printf(ic, "GET USER %s LASTONLINETIMESTAMP\n", nick);
+	skype_printf(ic, "GET USER %s BIRTHDAY\n", nick);
 	skype_printf(ic, "GET USER %s SEX\n", nick);
 	skype_printf(ic, "GET USER %s LANGUAGE\n", nick);
@@ -1478,10 +1454,4 @@
 	skype_printf(ic, "GET USER %s HOMEPAGE\n", nick);
 	skype_printf(ic, "GET USER %s ABOUT\n", nick);
-	/*
-	 * Hack: we query the bithday property which is always a single line,
-	 * so we can send the collected properties to the user when we have
-	 * this one.
-	 */
-	skype_printf(ic, "GET USER %s BIRTHDAY\n", nick);
 }
 